<script context="module">
    export async function preload({ params }) {
        return { username: params.username }
    }
</script>

<script>
    import { beforeUpdate, onMount } from 'svelte'
    import Header from 'components/Header.svelte'
    import ProfileMenu from 'components/ProfileMenu.svelte'
    import Post from 'components/Post/Post.svelte'
    import Avatar from 'components/User/Avatar.svelte'
    import Name from 'components/User/Name.svelte'
    import Username from 'components/User/Username.svelte'
    import Spinner from 'components/Icons/Spinner.svelte'
    import ToggleRelation from 'components/Relations/ToggleRelation.svelte'
    import { user as loggedUser, awaitingAPI } from 'store'
    import { get } from 'lib/fetch'

    export let username

    let user = { name: '', avatar: '', bio: '', posts: [] }
    $: isSelf = $loggedUser ? $loggedUser?.username === username : undefined

    onMount(async () => {
        if (isSelf) {
            loggedUser.subscribe(u => (user = u))
            await getSelfPosts()
        }
    })

    beforeUpdate(async () => {
        if (user?.name === '' || user?.username !== username) {
            if (!isSelf) {
                const { req, res } = await get('api/user/show', { username })
                if (req.ok) {
                    user = res
                }
            }
        }
    })

    const getSelfPosts = async () => {
        const { req, res } = await get('api/user/profile')
        if (req.ok) {
            loggedUser.update(u => {
                /*
                 * Nous récupérons les posts du plus ancien au plus récent.
                 * Pour rendre l'affichage plus logique, nous inversons la
                 * liste des posts pour l'afficher dans l'ordre décroissant de publication
                 */
                u.posts = res.data.reverse()
                return u
            })
        }
    }
</script>

{#if user}
    <Header withBackLink withBorder={false}>
        <div class="profile" slot="override">
            <div>
                <Avatar src={user.avatar} name={user.name} />
                {#if isSelf !== undefined}
                    {#if isSelf}
                        <ProfileMenu />
                    {:else}
                        <ToggleRelation {username} />
                    {/if}
                {/if}
            </div>
            <Name>{user.name}</Name>
            <Username>@{username}</Username>
            {#if user.bio}
                <p class="bio">{user.bio}</p>
            {/if}
        </div>
        <ul class="tabs" slot="nav">
            <button class="tab active">Messages</button>
        </ul>
    </Header>

    <section>
        {#if !$awaitingAPI && user.posts}
            {#each user.posts as post}
                <Post {post} />
            {:else}
                <div class="no-content">
                    Aucun post pour le moment.<br />
                    Ecris-en un pour alimenter ton profil !
                </div>
            {/each}
        {:else}
            <div class="no-content">
                <Spinner />
            </div>
        {/if}
    </section>
{/if}

<style lang="postcss">
    .profile {
        @apply flex flex-col flex-1 items-start mt-12 min-w-0;

        div {
            @apply w-full mb-3 flex items-center justify-between;
        }

        .bio {
            @apply w-full mt-3 text-blueGray-800 break-words whitespace-pre-line;
        }
    }

    .tabs {
        @apply w-full flex;

        .tab {
            @apply flex-1 py-3;

            &.active {
                @apply text-teal-500 border-b-2 border-teal-500;
            }
        }
    }

    section {
        .no-content  {
            @apply w-full flex justify-center p-4 text-center text-blueGray-500;
        }
    }
</style>
